## cegui-mk2 0.8.7

=== CMakeLists.txt ===
################################################################################
# Top-level CMakeLists.txt file for Crazy Eddie's GUI System
################################################################################
cmake_minimum_required(VERSION 2.8.11)
if (POLICY CMP0017)
    cmake_policy(SET CMP0017 OLD)
endif()

if (POLICY CMP0045)
    cmake_policy(SET CMP0045 OLD)
endif()

if (APPLE AND NOT CMAKE_OSX_ARCHITECTURES)
    set( CMAKE_OSX_ARCHITECTURES x86_64 CACHE STRING "Build architectures for Mac OS X")
endif()

# default to Release build (it's what most people will use, except cegui devs)
if (NOT CMAKE_BUILD_TYPE)
    set( CMAKE_BUILD_TYPE Release CACHE STRING "Sets the configuration to build (Release, Debug, etc...)")
endif()

################################################################################
# Start of main Project definitions
################################################################################
project(cegui)

set (CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${PROJECT_SOURCE_DIR}/cmake")
include(CEGUIMacros)
include(CMakeDependentOption)

################################################################################
# Set up version information
################################################################################
set( CEGUI_VERSION_MAJOR 0)
set( CEGUI_VERSION_MINOR 8)
set( CEGUI_VERSION_PATCH 7)
set( CEGUI_VERSION ${CEGUI_VERSION_MAJOR}.${CEGUI_VERSION_MINOR}.${CEGUI_VERSION_PATCH} )

#
# This controls the binary versioning - which is different to release versions
# defined above.
#
# The following describes what these components are and how they are intended to
# be managed.
#
#   - CURRENT: The binary interface version provided by the library.
#   - REVISION: Revision of binary interface specified in CURRENT
#   - AGE: Number of previous binary interfaces this library is compatible with.
#
# Prior to issuing a release, modify the values as follows:
#   - If there were no changes to the source, do not change any values.
#   - If there were changes to the implementation, but no changes to the ABI at all (that is, nothing was added, removed, or changed that affects ABI), increase REVISION.
#   - If there were changes that modified the ABI, but the ABI remains compatible with the previous release, increase CURRENT, increase AGE, and set REVISION to 0.
#   - If there were ABI breaking changes, increase CURRENT, set AGE to 0 and set REVISION to 0.
#
set( CEGUI_ABI_CURRENT 6)
set( CEGUI_ABI_REVISION 2)
set( CEGUI_ABI_AGE 4)
MATH( EXPR CEGUI_SOVERSION ${CEGUI_ABI_CURRENT}-${CEGUI_ABI_AGE} )
set( CEGUI_ABI_VERSION ${CEGUI_SOVERSION}.${CEGUI_ABI_AGE}.${CEGUI_ABI_REVISION} )


################################################################################
# Check for libs and other packages we might use.
################################################################################
# be sure to search the provided dependencies on Win32 and Mac OS X platforms
if ((WIN32 OR APPLE) AND NOT CMAKE_PREFIX_PATH)
    set (CMAKE_PREFIX_PATH "${PROJECT_SOURCE_DIR}/dependencies" CACHE PATH "Path to dependencies")
    # prefer the dylib deps in the dependencies over some other framework
    set (CMAKE_FIND_FRAMEWORK LAST)
endif()

if ((CMAKE_CXX_COMPILER_ID STREQUAL "GNU") OR (CMAKE_CXX_COMPILER_ID STREQUAL "Clang"))
    set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -std=c99")
    set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++03")
elseif (NOT CMAKE_VERSION VERSION_LESS "3.1")
    set (CMAKE_C_STANDARD_REQUIRED TRUE)
    set (CMAKE_C_STANDARD "99")
endif ()

# Look for packages
find_package(PCRE)
find_package(Freetype)
find_package(Minizip)
find_package(Fribidi)
if (NOT WIN32)
    find_package(Iconv REQUIRED)
endif()

find_package(OpenGL)
find_package(GLEW)
find_package(GLM)
find_package(GLFW)
find_package(GLFW3)
find_package(SDL2)
find_package(SDL2_image)
find_package(DirectXSDK)
find_package(D3DX11Effects)
find_package(Irrlicht)
find_package(Ogre)
find_package(OIS)
find_package(DirectFB)
find_package(OpenGLES)
find_package(Epoxy)

find_package(EXPAT)
find_package(XercesC)
find_package(LibXml2)
find_package(TinyXML)
find_package(RapidXML)

find_package(DevIL)
find_package(FreeImage)
find_package(SILLY)
find_package(Corona)
find_package(PVRTools)

find_package(Lua51)
find_package(TOLUAPP)
find_package(PythonInterp)

## ensure python3 not picked up as default
find_package(PythonVersion)
if (UNIX AND PYTHON_VERSION_FOUND)
  find_package(PythonLibs ${PYTHON_VERSION_STRING} EXACT)
else()
  find_package(PythonLibs)
endif()
find_package(Boost)

find_package(Doxygen)
find_package(GTK2 COMPONENTS gtk)
# set for consistency with other deps
set (GTK2_INCLUDE_DIR ${GTK2_INCLUDE_DIRS})

## Search for ccache
find_program(CCACHE_FOUND ccache)
if(CCACHE_FOUND)
    set(ENV(CCACHE_CPP2) "yes")
    set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE ccache)
    set_property(GLOBAL PROPERTY RULE_LAUNCH_LINK ccache)
endif(CCACHE_FOUND)

if (GLEW_FOUND OR EPOXY_FOUND)
    set (OPENGL_LOADER_FOUND TRUE)
else ()
    set (OPENGL_LOADER_FOUND FALSE)
endif ()

################################################################################
# Define the configurable options
################################################################################
cmake_dependent_option( CEGUI_MSVC_STATIC_RUNTIME "Specifies whether to the static runtime (/MT and /MTd) or the DLL runtime (/MD and /MDd).
NOTE: This will also affect which set of dependency libraries are linked with." FALSE "MSVC" FALSE )
cmake_dependent_option( CEGUI_BUILD_SHARED_LIBS_WITH_STATIC_DEPENDENCIES "For WIN32 and APPLE where the dependency pack is used, prefer the static
dependency libs over the shared/dynamic ones.  NOTE: On Windows you also need to
be mindful of which C/C++ runtime setting has been used to compile the various
components - they must all match or you will get crashes, heap corruption and/or
other issues." FALSE "WIN32 OR APPLE" FALSE)
option( CEGUI_BUILD_STATIC_CONFIGURATION "Specifies whether the static configs will be built.  (NB: Shared configs are always built)" FALSE)
option( CEGUI_BUILD_STATIC_FACTORY_MODULE "For static CEGUI builds, specifies whether to include the getWindoFactoryModule method.  When false, the developer must provide a custom implementation of the method" FALSE)
# sanity check on static build option for factory method
if (CEGUI_BUILD_STATIC_FACTORY_MODULE AND NOT CEGUI_BUILD_STATIC_CONFIGURATION)
  message(SEND_ERROR "You may not enable CEGUI_BUILD_STATIC_FACTORY_MODULE without CEGUI_BUILD_STATIC_CONFIGURATION enabled.  CEGUI needs to be built statically if building the static factory method.")
endif()
option( CEGUI_CUSTOM_ALLOCATORS "If checked, CEGUI can use custom allocation. (for experienced developers only!)" FALSE )
cmake_dependent_option( CEGUI_CUSTOM_ALLOCATORS_DEBUG "If checked, CEGUI allocations will pass debug info to allocators. (only used if CEGUI_CUSTOM_ALLOCATORS is checked)" FALSE "CEGUI_CUSTOM_ALLOCATORS" FALSE )
set( CEGUI_CUSTOM_ALLOCATORS_INCLUDE "CEGUI/MemoryStdAllocator.h" CACHE STRING "Which include file contains memory allocators and allocation configuration. (only used if CEGUI_CUSTOM_ALLOCATORS is checked)
We have bundled 2 allocators, mostly for demonstrational purposes.
CEGUI/MemoryStdAllocator.h contains malloc allocator, use it as a starting point for your own allocators
CEGUI/MemoryOgreAllocator.h delegates allocation to Ogre, which may be useful to Ogre users (you will have to manually change linking options of CEGUIBase!)" )

set( CEGUI_STRING_CLASS 1 CACHE INT "Which string class should CEGUI use
1 - utf8 and utf32 aware inbuilt string,
2 - std::string without custom allocation,
3 - std::basic_string allocated according to allocator config" )

# sanity check std::basic_string and allocator and allocators actually being used
if (${CEGUI_STRING_CLASS} MATCHES 3 AND NOT CEGUI_CUSTOM_ALLOCATORS)
    message(SEND_ERROR "You requested std::basic_string allocated according to allocator as CEGUI::String even though CEGUI is not being built with custom allocators enabled!")
endif()

option( CEGUI_HAS_FREETYPE "Specifies whether to include Freetype font support" ${FREETYPE_FOUND} )
option( CEGUI_HAS_PCRE_REGEX "Specifies whether to include PCRE regexp matching for editbox string validation" ${PCRE_FOUND} )
option( CEGUI_HAS_MINIZIP_RESOURCE_PROVIDER "Specifies whether to build the minizip based resource provider" ${MINIZIP_FOUND} )
option( CEGUI_HAS_DEFAULT_LOGGER "Specifies whether to build the DefaultLogger implementation" TRUE)

option( CEGUI_BUILD_XMLPARSER_EXPAT "Specifies whether to build the Expat based XMLParser module" ${EXPAT_FOUND} )
option( CEGUI_BUILD_XMLPARSER_XERCES "Specifies whether to build the Xerces-C++ based XMLParser module" ${XERCESC_FOUND} )
option( CEGUI_BUILD_XMLPARSER_LIBXML2 "Specifies whether to build the libxml2 based XMLParser module" ${LIBXML2_FOUND} )
option( CEGUI_BUILD_XMLPARSER_RAPIDXML "Specifies whether to build the RapidXML based XMLParser module" ${RAPIDXML_FOUND} )
option( CEGUI_BUILD_XMLPARSER_TINYXML "Specifies whether to build the TinyXML based XMLParser module" ${TINYXML_FOUND} )

option( CEGUI_BUILD_IMAGECODEC_SILLY "Specifies whether to build the SILLY based ImageCodec module" ${SILLY_FOUND} )
option( CEGUI_BUILD_IMAGECODEC_DEVIL "Specifies whether to build the DevIL based ImageCodec module" ${IL_FOUND} )
option( CEGUI_BUILD_IMAGECODEC_FREEIMAGE "Specifies whether to build the FreeImage based ImageCodec module" ${FREEIMAGE_FOUND} )
option( CEGUI_BUILD_IMAGECODEC_CORONA "Specifies whether to build the Corona based ImageCodec module" ${CORONA_FOUND} )
option( CEGUI_BUILD_IMAGECODEC_STB "Specifies whether to build the STB based ImageCodec module" FALSE )
option( CEGUI_BUILD_IMAGECODEC_TGA "Specifies whether to build the based TGA only ImageCodec module" FALSE )
option( CEGUI_BUILD_IMAGECODEC_PVR "Specifies whether to build the PVR only ImageCodec module" ${PVRTOOLS_FOUND} )
cegui_dependent_option( CEGUI_BUILD_IMAGECODEC_SDL2 "Specifies whether to build the SDL2 ImageCodec module" "SDL2_FOUND;SDL2IMAGE_FOUND" )

cegui_dependent_option( CEGUI_BUILD_RENDERER_OPENGL "Specifies whether to build the old OpenGL renderer module" "OPENGL_gl_LIBRARY;GLM_FOUND;GLEW_FOUND" )
cegui_dependent_option( CEGUI_BUILD_RENDERER_OPENGL3 "Specifies whether to build the renderer module that supports OpenGL 3.2 (core profile) and OpenGL ES 2.0." "OPENGL_gl_LIBRARY;GLM_FOUND;OPENGL_LOADER_FOUND")
option( CEGUI_BUILD_RENDERER_OGRE "Specifies whether to build the Ogre renderer module" ${OGRE_FOUND} )
option( CEGUI_BUILD_RENDERER_IRRLICHT "Specifies whether to build the Irrlicht renderer module" ${IRRLICHT_FOUND} )
option( CEGUI_BUILD_RENDERER_DIRECTFB "Specifies whether to build the DirectFB renderer module (not supported!)" FALSE )
cegui_dependent_option( CEGUI_BUILD_RENDERER_DIRECT3D9 "Specifies whether to build the Direct3D 9 renderer module" "DIRECTXSDK_FOUND;NOT DIRECTXSDK_MAX_D3D LESS 9" )
cegui_dependent_option( CEGUI_BUILD_RENDERER_DIRECT3D10 "Specifies whether to build the Direct3D 10 renderer module" "DIRECTXSDK_FOUND;NOT DIRECTXSDK_MAX_D3D LESS 10" )
cegui_dependent_option( CEGUI_BUILD_RENDERER_DIRECT3D11 "Specifies whether to build the Direct3D 11 renderer module" "DIRECTXSDK_FOUND;D3DX11EFFECTS_FOUND;NOT DIRECTXSDK_MAX_D3D LESS 11" )
option( CEGUI_BUILD_RENDERER_NULL "Specifies whether to build the null renderer module" FALSE )
option( CEGUI_BUILD_RENDERER_OPENGLES "Specifies whether to build the OpenGL ES 1 renderer module" ${OPENGLES_FOUND} )
cegui_dependent_option( CEGUI_BUILD_LUA_MODULE "Specifies whether to build the Lua based script module" "LUA51_FOUND;TOLUAPP_FOUND" )
cegui_dependent_option( CEGUI_BUILD_LUA_GENERATOR "Specifies whether to build the custom tolua binding generator 'toluappcegui'" "LUA51_FOUND;TOLUAPP_FOUND" )

cegui_dependent_option( CEGUI_BUILD_PYTHON_MODULES "Specifies whether to build the Python extension module(s)" "PYTHONINTERP_FOUND;PYTHONLIBS_FOUND;Boost_PYTHON_FOUND" )

=== application_templates/CMakeLists.txt ===
cegui_dependent_option(CEGUI_BUILD_APPLICATION_TEMPLATE_SDL2 "Specifies whether to build the application template for SDL2" "SDL2_FOUND;CEGUI_BUILD_RENDERER_OPENGL")
cegui_dependent_option(CEGUI_BUILD_APPLICATION_TEMPLATE_GLFW3 "Specifies whether to build the application template for GLFW3" "GLFW3_FOUND;CEGUI_BUILD_RENDERER_OPENGL")

if(CEGUI_BUILD_RENDERER_OPENGL)
    if(${CEGUI_BUILD_APPLICATION_TEMPLATE_SDL2})
        add_executable(CEGUITemplate_SDL2 SDL2.cpp)
        
        cegui_target_link_libraries(CEGUITemplate_SDL2 ${CEGUI_BASE_LIBNAME})
        cegui_target_link_libraries(CEGUITemplate_SDL2 ${CEGUI_OPENGL_RENDERER_LIBNAME})
        cegui_add_dependency(CEGUITemplate_SDL2 SDL2)
    endif()

    if(${CEGUI_BUILD_APPLICATION_TEMPLATE_GLFW3})
        add_executable(CEGUITemplate_GLFW3 glfw3.cpp)
        if (WIN32)
            set_property (TARGET CEGUITemplate_GLFW3 PROPERTY WIN32_EXECUTABLE TRUE)
        endif ()
        
        cegui_target_link_libraries(CEGUITemplate_GLFW3 ${CEGUI_BASE_LIBNAME})
        cegui_target_link_libraries(CEGUITemplate_GLFW3 ${CEGUI_OPENGL_RENDERER_LIBNAME})
        cegui_add_dependency(CEGUITemplate_GLFW3 GLFW3)

    endif()
endif()

=== samples/CMakeLists.txt ===
# We clear the samples.xml file, which will be used by the samples browser, and
# add the samples header to it before starting to add the samples 
file(WRITE ${CMAKE_BINARY_DIR}/datafiles/samples/samples.xml "")
file(READ ${CMAKE_CURRENT_SOURCE_DIR}/common/SamplesXmlHeader.xml DEMO_META_DATA)
file(APPEND ${CMAKE_BINARY_DIR}/datafiles/samples/samples.xml ${DEMO_META_DATA})

add_subdirectory(HelloWorld)
add_subdirectory(LookNFeelOverview)

add_subdirectory(GameMenu)
add_subdirectory(HUDDemo)
add_subdirectory(DragDropDemo)
add_subdirectory(InventoryDemo)
add_subdirectory(EffectsDemo)
add_subdirectory(FontDemo)
add_subdirectory(Demo6)

add_subdirectory(EditboxValidationDemo)
add_subdirectory(Minesweeper)
add_subdirectory(ScrollablePaneDemo)
add_subdirectory(TabControlDemo)
add_subdirectory(CommonDialogsDemo)
add_subdirectory(WidgetDemo)
add_subdirectory(TextDemo)
add_subdirectory(TreeDemo)

if (CEGUI_BUILD_LUA_MODULE)
    # add_subdirectory(Demo8)
endif()

# Simple test for GLES renderer.
#
# Commented since it's does not use the samples framework and is merely included
# such that recreation from scratch is not required in the future.  Aka, it's
# one of CrazyEddie's hacks that he wants to keep around :-p
#if (CEGUI_BUILD_RENDERER_OPENGLES)
#    add_subdirectory(GLESTest)
#endif()


# Finally we add the samples footer to the samples.xml
file(READ ${CMAKE_CURRENT_SOURCE_DIR}/common/SamplesXmlFooter.xml DEMO_META_DATA)
file(APPEND ${CMAKE_BINARY_DIR}/datafiles/samples/samples.xml ${DEMO_META_DATA})

# And add it to the install
install(FILES ${CMAKE_BINARY_DIR}/datafiles/samples/samples.xml
        DESTINATION ${CEGUI_DATA_INSTALL_DIR}/samples/)

=== samples_framework/CMakeLists.txt ===
set( CEGUI_TARGET_NAME ${CEGUI_SAMPLEFRAMEWORK_EXENAME} )

set( CORE_SOURCE_FILES
    ./src/SamplesFrameworkBase.cpp
    ./src/SamplesFramework.cpp
    ./src/CEGuiBaseApplication.cpp
    ./src/CEGuiRendererSelector.cpp
    ./src/Samples_xmlHandler.cpp
    ./src/SampleData.cpp
    ./src/MetaDataWindowManager.cpp
    ./src/SamplesBrowserManager.cpp
)

set( CORE_HEADER_FILES
    ../samples/common/include/Sample.h
    ./include/SamplesFrameworkBase.h
    ./include/SamplesFramework.h
    ./include/CEGuiBaseApplication.h
    ./include/CEGuiRendererSelector.h
    ./include/Samples_xmlHandler.h
    ./include/SampleData.h
    ./include/MetaDataWindowManager.h
    ./include/SamplesBrowserManager.h
)


include_directories(${CMAKE_SOURCE_DIR}/samples_framework/include
                    ${CMAKE_BINARY_DIR}/samples/common/include
                    ${CMAKE_SOURCE_DIR}/samples/common/include
                    ${CMAKE_SOURCE_DIR}/cegui/include)

if (WIN32)
    list (APPEND CORE_SOURCE_FILES
        ./src/Win32AppHelper.cpp
        ./src/Win32CEGuiRendererSelector.cpp
    )
elseif (APPLE)
    list (APPEND CORE_SOURCE_FILES
        ./src/MacCEGuiRendererSelector.mm
    )
elseif (CEGUI_SAMPLES_USE_GTK2)
    list (APPEND CORE_SOURCE_FILES
        ./src/GTK2CEGuiRendererSelector.cpp
    )
else()
    list (APPEND CORE_SOURCE_FILES
        ./src/CLICEGuiRendererSelector.cpp
    )
endif()

if (ANDROID)
    list (APPEND CORE_SOURCE_FILES
        ./src/SamplesFrameworkAndroid.cpp
    )
endif ()

if (CEGUI_SAMPLES_RENDERER_OPENGL_ACTIVE)
    if (NOT ANDROID)

        list (APPEND CORE_SOURCE_FILES
            ./src/CEGuiGLFWSharedBase.cpp
        )
        if (CEGUI_USE_GLFW_VER STREQUAL "3")
            list (APPEND CORE_SOURCE_FILES
                ./src/CEGuiGLFW3SharedBase.cpp
            )
        else() # CEGUI_USE_GLFW_VER STREQUAL "2"
            list (APPEND CORE_SOURCE_FILES
                ./src/CEGuiGLFW2SharedBase.cpp
            )
        endif()

        if (CEGUI_BUILD_RENDERER_OPENGL)
            list (APPEND CORE_SOURCE_FILES
                ./src/CEGuiOpenGLBaseApplication.cpp
            )
        endif()

        if (CEGUI_BUILD_RENDERER_OPENGL3)
            list (APPEND CORE_SOURCE_FILES
                ./src/CEGuiOpenGL3BaseApplication.cpp
            )
        endif()

    endif ()

    if (CEGUI_SAMPLES_SUPPORT_RENDERER_OPENGLES2)
        if (ANDROID)
            list (APPEND CORE_SOURCE_FILES
                ./src/CEGuiAndroidOpenglEs2BaseApplication.cpp
            )
        else ()
            list (APPEND CORE_SOURCE_FILES
                ./src/CEGuiOpenGLES2BaseApplication.cpp
            )
        endif ()
    endif()

endif()

if (CEGUI_SAMPLES_RENDERER_OGRE_ACTIVE)
    # this prevents the boost auto-link dis-feature
    add_definitions(-DBOOST_ALL_NO_LIB)

    list (APPEND CORE_SOURCE_FILES
        ./src/CEGuiOgreBaseApplication.cpp
    )
endif()

if (CEGUI_SAMPLES_RENDERER_IRRLICHT_ACTIVE)
    list (APPEND CORE_SOURCE_FILES
        ./src/CEGuiIrrlichtBaseApplication.cpp
    )
endif()

if (CEGUI_SAMPLES_RENDERER_DIRECT3D9_ACTIVE)
    list (APPEND CORE_SOURCE_FILES
        ./src/CEGuiD3D9BaseApplication.cpp
        ./src/DeviceReset_Direct3D9.cpp
    )
endif()

if (CEGUI_SAMPLES_RENDERER_DIRECT3D10_ACTIVE)
    list (APPEND CORE_SOURCE_FILES
        ./src/CEGuiD3D10BaseApplication.cpp
        ./src/DeviceReset_Direct3D10.cpp
    )
endif()

if (CEGUI_SAMPLES_RENDERER_DIRECT3D11_ACTIVE)
    list (APPEND CORE_SOURCE_FILES
        ./src/CEGuiD3D11BaseApplication.cpp
        ./src/DeviceReset_Direct3D11.cpp
    )
endif()

if (CEGUI_SAMPLES_RENDERER_DIRECTFB_ACTIVE)
    list (APPEND CORE_SOURCE_FILES
        ./src/CEGuiDirectFBBaseApplication.cpp
    )
endif()

if (CEGUI_SAMPLES_RENDERER_DIRECT3D9_ACTIVE OR CEGUI_SAMPLES_RENDERER_DIRECT3D10_ACTIVE OR CEGUI_SAMPLES_RENDERER_DIRECT3D11_ACTIVE)
    include_directories(${DIRECTXSDK_INCLUDE_DIR})
    link_directories(${DIRECTXSDK_LIBRARY_DIR})
endif()

###########################################################################
#                     Statically Linked Executable
###########################################################################
if (CEGUI_BUILD_STATIC_CONFIGURATION)
    add_executable(${CEGUI_TARGET_NAME}_Static ${CORE_SOURCE_FILES} ${CORE_HEADER_FILES})
    set_property(TARGET ${CEGUI_TARGET_NAME}_Static APPEND PROPERTY COMPILE_DEFINITIONS CEGUI_STATIC)

    # append the _d (or whatever) for debug builds as needed.
    if (CEGUI_HAS_BUILD_SUFFIX AND CEGUI_BUILD_SUFFIX)
        set_target_properties(${CEGUI_TARGET_NAME}_Static PROPERTIES
            OUTPUT_NAME_DEBUG "${CEGUI_TARGET_NAME}_Static${CEGUI_BUILD_SUFFIX}"
        )
    endif()

    # This works around an issue in the prebuilt deps and can be removed once those are fixed :)
    if (WIN32)
        set_target_properties(${CEGUI_TARGET_NAME}_Static PROPERTIES LINK_FLAGS_DEBUG /NODEFAULTLIB:freeglut.lib)
    endif()

    if (APPLE)
        cegui_apple_app_setup(${CEGUI_TARGET_NAME}_Static TRUE)
    endif()
endif()

###########################################################################
#                   Dynamically Linked Executable
###########################################################################
if (ANDROID)
    add_library (${CEGUI_TARGET_NAME} SHARED ${CORE_SOURCE_FILES})
else ()
    add_executable(${CEGUI_TARGET_NAME} ${CORE_SOURCE_FILES} ${CORE_HEADER_FILES})
endif ()

# append the _d (or whatever) for debug builds as needed.
if (CEGUI_HAS_BUILD_SUFFIX AND CEGUI_BUILD_SUFFIX)
    set_target_properties(${CEGUI_TARGET_NAME} PROPERTIES
        OUTPUT_NAME_DEBUG "${CEGUI_TARGET_NAME}${CEGUI_BUILD_SUFFIX}"
    )
endif()

if (NOT APPLE AND CEGUI_INSTALL_WITH_RPATH)
    set_target_properties(${CEGUI_TARGET_NAME} PROPERTIES
        INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${CEGUI_LIB_INSTALL_DIR}"
    )
endif()

if (APPLE)
    # we add these to ensure the dynamically loaded modules we will be
    # using are built before the .app's post build step that copies
    # libs into the app bundle.
    add_dependencies(${CEGUI_TARGET_NAME} ${CEGUI_CORE_WR_LIBNAME}
                                          CEGUI${CEGUI_OPTION_DEFAULT_XMLPARSER}
                                          CEGUI${CEGUI_OPTION_DEFAULT_IMAGECODEC}
    )

    cegui_apple_app_setup(${CEGUI_TARGET_NAME} FALSE)
endif()

###########################################################################
#                    MSVC PROJ USER FILE TEMPLATES
###########################################################################
if(MSVC)
    # Visual Studio 2008 or less
    if (CMAKE_CXX_COMPILER_VERSION VERSION_LESS 16.0)
        configure_file(
            ${CMAKE_MODULE_PATH}/templates/VisualStudioUserFile.vcproj.user.in
            ${CMAKE_CURRENT_BINARY_DIR}/${CEGUI_TARGET_NAME}.vcproj.user
            @ONLY
        )
    else ()
    # Visual Studio 2010 or higher
        configure_file(
            ${CMAKE_MODULE_PATH}/templates/VisualStudioUserFile.vcxproj.user.in
            ${CMAKE_CURRENT_BINARY_DIR}/${CEGUI_TARGET_NAME}.vcxproj.user
            @ONLY
            )
    endif ()
endif()


###########################################################################
#                      LIBRARY LINK SETUP
###########################################################################
cegui_target_link_libraries(${CEGUI_TARGET_NAME} ${CEGUI_BASE_LIBNAME})

if (CEGUI_BUILD_STATIC_CONFIGURATION)
    target_link_libraries(${CEGUI_TARGET_NAME}_Static
        ${CEGUI_STATIC_XMLPARSER_MODULE}_Static
        ${CEGUI_STATIC_IMAGECODEC_MODULE}_Static
        ${CEGUI_CORE_WR_LIBNAME}_Static
    )
endif()

###########################################################################
#  BUILD DEPENDENCIES FOR THE SHARED LIBRARIES USED BY THE SAMPLEBROWSER
###########################################################################

add_dependencies(${CEGUI_TARGET_NAME} ${CEGUI_CORE_WR_LIBNAME}
                                      CEGUI${CEGUI_OPTION_DEFAULT_XMLPARSER}
                                      CEGUI${CEGUI_OPTION_DEFAULT_IMAGECODEC})

if (CEGUI_SAMPLES_ENABLE_COMMON_DIALOGUES_DEMO)
    add_dependencies(${CEGUI_TARGET_NAME} ${CEGUI_COMMON_DIALOGS_LIBNAME})
endif()

###########################################################################
#                           INSTALLATION
###########################################################################
install(TARGETS ${CEGUI_TARGET_NAME}
    RUNTIME DESTINATION bin
    LIBRARY DESTINATION ${CEGUI_LIB_INSTALL_DIR}
    ARCHIVE DESTINATION ${CEGUI_LIB_INSTALL_DIR}
    BUNDLE DESTINATION ${CEGUI_LIB_INSTALL_DIR}
)

if (CEGUI_BUILD_STATIC_CONFIGURATION)
    install(TARGETS ${CEGUI_TARGET_NAME}_Static
        RUNTIME DESTINATION bin
        LIBRARY DESTINATION ${CEGUI_LIB_INSTALL_DIR}
        ARCHIVE DESTINATION ${CEGUI_LIB_INSTALL_DIR}
        BUNDLE DESTINATION ${CEGUI_LIB_INSTALL_DIR}
)
endif()

if (CEGUI_SAMPLES_RENDERER_OPENGL_ACTIVE)
    if (CEGUI_USE_EPOXY)
        cegui_add_dependency(${CEGUI_TARGET_NAME} EPOXY)
    elseif (CEGUI_USE_GLEW)
        cegui_add_dependency(${CEGUI_TARGET_NAME} OPENGL)
    endif ()
    if (CEGUI_USE_GLFW_VER STREQUAL "3")
        cegui_add_dependency(${CEGUI_TARGET_NAME} GLFW3)
    else () # CEGUI_USE_GLFW_VER STREQUAL "2"
        cegui_add_dependency(${CEGUI_TARGET_NAME} GLFW)
    endif ()
    cegui_target_link_libraries(${CEGUI_TARGET_NAME} ${CEGUI_OPENGL_RENDERER_LIBNAME})
endif()

if (CEGUI_SAMPLES_RENDERER_OGRE_ACTIVE)
    cegui_add_dependency(${CEGUI_TARGET_NAME} OIS PRIVATE TRUE)
    if (CEGUI_SAMPLES_RENDERER_OGRE_ACTIVE)
        if (OGRE_STATIC) #if ogre is static, then must include the static plugin libs
            set(CORE_OGRE_COMPONENTS RenderSystem_Direct3D9 RenderSystem_Direct3D11 RenderSystem_GLES RenderSystem_GLES2 RenderSystem_GL RenderSystem_GL3Plus)
            foreach (comp ${CORE_OGRE_COMPONENTS})
                if (${OGRE_${comp}_FOUND})
                    include_directories(${OGRE_${comp}_INCLUDE_DIRS})
                    target_link_libraries(${CEGUI_TARGET_NAME} ${OGRE_${comp}_LIBRARIES})
                    if (CEGUI_BUILD_STATIC_CONFIGURATION)
                        target_link_libraries(${CEGUI_TARGET_NAME}_Static ${OGRE_${comp}_LIBRARIES})
                    endif()
                endif()
            endforeach (comp)
       endif()
    endif()
    cegui_target_link_libraries(${CEGUI_TARGET_NAME} ${CEGUI_OGRE_RENDERER_LIBNAME} ${CEGUI_OGRE_SAMPLES_EXTRALIBS})
endif()

if (CEGUI_SAMPLES_RENDERER_IRRLICHT_ACTIVE)
    cegui_target_link_libraries(${CEGUI_TARGET_NAME} ${CEGUI_IRRLICHT_RENDERER_LIBNAME})
endif()

if (CEGUI_SAMPLES_RENDERER_DIRECT3D9_ACTIVE OR CEGUI_SAMPLES_RENDERER_DIRECT3D10_ACTIVE OR CEGUI_SAMPLES_RENDERER_DIRECT3D11_ACTIVE)

    if (MINGW)
        cegui_target_link_libraries(${CEGUI_TARGET_NAME} dxerr9 dinput8 dxguid)
    else ()
        cegui_target_link_libraries(${CEGUI_TARGET_NAME} dxerr)
    endif()

    if (CEGUI_SAMPLES_RENDERER_DIRECT3D9_ACTIVE)
        cegui_target_link_libraries(${CEGUI_TARGET_NAME} ${CEGUI_DIRECT3D9_RENDERER_LIBNAME} d3d9)
    endif()

    if (CEGUI_SAMPLES_RENDERER_DIRECT3D10_ACTIVE)
        cegui_target_link_libraries(${CEGUI_TARGET_NAME} ${CEGUI_DIRECT3D10_RENDERER_LIBNAME})
        if (MINGW)
            cegui_target_link_libraries(${CEGUI_TARGET_NAME} d3dx10_43)
        else ()
            cegui_target_link_libraries(${CEGUI_TARGET_NAME} d3d10)
        endif()
    endif()

    if (CEGUI_SAMPLES_RENDERER_DIRECT3D11_ACTIVE)
        cegui_target_link_libraries(${CEGUI_TARGET_NAME} ${CEGUI_DIRECT3D11_RENDERER_LIBNAME})
        if (MINGW)
            cegui_target_link_libraries(${CEGUI_TARGET_NAME} d3xd11_43)
        else ()
            cegui_target_link_libraries(${CEGUI_TARGET_NAME} d3d11)
        endif()
    endif()

endif()

if (CEGUI_SAMPLES_RENDERER_DIRECTFB_ACTIVE)
    cegui_add_dependency(${CEGUI_TARGET_NAME} DIRECTFB)
    cegui_target_link_libraries(${CEGUI_TARGET_NAME} ${CEGUI_DIRECTFB_RENDERER_LIBNAME})

=== cegui/src/CMakeLists.txt ===
set( CEGUI_TARGET_NAME ${CEGUI_BASE_LIBNAME} )

# we do not use cegui_gather_files() here since our needs are more complex.
file (GLOB CORE_SOURCE_FILES RELATIVE "${CMAKE_CURRENT_SOURCE_DIR}" *.cpp)
file (GLOB WIDGET_SOURCE_FILES RELATIVE "${CMAKE_CURRENT_SOURCE_DIR}" widgets/*.cpp)
file (GLOB FALAGARD_SOURCE_FILES RELATIVE "${CMAKE_CURRENT_SOURCE_DIR}" falagard/*.cpp)
set (CORE_SOURCE_FILES ${CORE_SOURCE_FILES} ${WIDGET_SOURCE_FILES} ${FALAGARD_SOURCE_FILES})

file (GLOB CORE_HEADER_FILES ../include/CEGUI/*.h)
file (GLOB WIDGET_HEADER_FILES ../include/CEGUI/widgets/*.h)
file (GLOB FALAGARD_HEADER_FILES ../include/CEGUI/falagard/*.h)

list (APPEND CORE_HEADER_FILES
    ${CMAKE_CURRENT_BINARY_DIR}/../include/CEGUI/Config.h
    ${CMAKE_CURRENT_BINARY_DIR}/../include/CEGUI/ModuleConfig.h
    ${CMAKE_CURRENT_BINARY_DIR}/../include/CEGUI/Version.h
)

# We don't append all to CORE_HEADER_FILES since that would mess up installation
# on systems where files are installed.
set (ALL_HEADER_FILES ${CORE_HEADER_FILES} ${WIDGET_HEADER_FILES} ${FALAGARD_HEADER_FILES})

# never compile this directly, it's included in another file
list (REMOVE_ITEM CORE_SOURCE_FILES minibidi.cpp)

if (NOT CEGUI_HAS_DEFAULT_LOGGER)
    list (REMOVE_ITEM CORE_SOURCE_FILES DefaultLogger.cpp)
endif()

if (NOT CEGUI_HAS_FREETYPE)
    list (REMOVE_ITEM CORE_SOURCE_FILES FreeTypeFont.cpp)
endif()

if (NOT CEGUI_HAS_PCRE_REGEX)
    list (REMOVE_ITEM CORE_SOURCE_FILES PCRERegexMatcher.cpp)
endif()

if (NOT CEGUI_USE_FRIBIDI)
    list (REMOVE_ITEM CORE_SOURCE_FILES FribidiVisualMapping.cpp)
endif()

if (NOT CEGUI_USE_MINIBIDI)
    list (REMOVE_ITEM CORE_SOURCE_FILES MinibidiVisualMapping.cpp)
endif ()

if (NOT CEGUI_HAS_MINIZIP_RESOURCE_PROVIDER)
    list (REMOVE_ITEM CORE_SOURCE_FILES MinizipResourceProvider.cpp)
endif()

if (WIN32)
    list (REMOVE_ITEM CORE_SOURCE_FILES IconvStringTranscoder.cpp)
else()
    list (REMOVE_ITEM CORE_SOURCE_FILES Win32StringTranscoder.cpp)
endif()


# we do not use the common header install function since we need to install to
# multiple sub-dirs.
cegui_add_library_impl(${CEGUI_TARGET_NAME} FALSE CORE_SOURCE_FILES ALL_HEADER_FILES TRUE FALSE)
if (ANDROID)
    target_link_libraries (${CEGUI_TARGET_NAME} log)
endif ()

source_group("Source Files\\widget" FILES ${WIDGET_SOURCE_FILES})
source_group("Source Files\\falagard" FILES ${FALAGARD_SOURCE_FILES})

source_group("Header Files\\widget" FILES ${WIDGET_HEADER_FILES})
source_group("Header Files\\falagard" FILES ${FALAGARD_HEADER_FILES})

if (NOT WIN32 AND NOT ANDROID)
    cegui_add_dependency(${CEGUI_TARGET_NAME} ICONV)
endif()

if (CEGUI_HAS_FREETYPE)
    cegui_add_dependency(${CEGUI_TARGET_NAME} FREETYPE)
endif ()

if (CEGUI_HAS_PCRE_REGEX)
    cegui_add_dependency(${CEGUI_TARGET_NAME} PCRE)
endif ()

if (CEGUI_USE_FRIBIDI)
    cegui_add_dependency(${CEGUI_TARGET_NAME} FRIBIDI)
endif ()

if (CEGUI_HAS_MINIZIP_RESOURCE_PROVIDER)
    cegui_add_dependency(${CEGUI_TARGET_NAME} MINIZIP)
    if (MINGW)
        target_link_libraries(${CEGUI_TARGET_NAME} shlwapi)
    endif ()
endif ()

if (WIN32 AND NOT MINGW)
    cegui_target_link_libraries(${CEGUI_TARGET_NAME} winmm debug DbgHelp)
elseif (UNIX AND NOT APPLE)
    # This is intentionally not using 'cegui_target_link_libraries'
    target_link_libraries(${CEGUI_TARGET_NAME} ${CMAKE_DL_LIBS})
elseif (MINGW)
    cegui_target_link_libraries(${CEGUI_TARGET_NAME} ${CMAKE_DL_LIBS})
endif()

if (APPLE AND CEGUI_BUILD_SHARED_LIBS_WITH_STATIC_DEPENDENCIES)
    set_property(TARGET ${CEGUI_TARGET_NAME} APPEND PROPERTY LINK_FLAGS "-framework Carbon")
endif()

install(FILES ${CORE_HEADER_FILES} DESTINATION ${CEGUI_INCLUDE_INSTALL_DIR}/CEGUI)
install(FILES ${WIDGET_HEADER_FILES} DESTINATION ${CEGUI_INCLUDE_INSTALL_DIR}/CEGUI/widgets)
install(FILES ${FALAGARD_HEADER_FILES} DESTINATION ${CEGUI_INCLUDE_INSTALL_DIR}/CEGUI/falagard)

=== samples/DragDropDemo/CMakeLists.txt ===
option(CEGUI_SAMPLES_ENABLE_DRAGDROP_DEMO "Specifies whether this sample should be built or not" TRUE)
if(CEGUI_SAMPLES_ENABLE_DRAGDROP_DEMO)
    cegui_add_sample(CEGUIDragDropDemo)
endif()

=== samples/FontDemo/CMakeLists.txt ===
option(CEGUI_SAMPLES_ENABLE_FONT_DEMO "Specifies whether this sample should be built or not" TRUE)
if(CEGUI_SAMPLES_ENABLE_FONT_DEMO)
    cegui_add_sample(CEGUIFontDemo)
endif()

=== samples/WidgetDemo/CMakeLists.txt ===
option(CEGUI_SAMPLES_ENABLE_WIDGET_DEMO "Specifies whether this sample should be built or not" TRUE)
if(CEGUI_SAMPLES_ENABLE_WIDGET_DEMO)
    file(GLOB WIDGET_HEADERS "${CMAKE_SOURCE_DIR}/cegui/include/CEGUI/widgets/*.h")
    list(APPEND WIDGET_HEADERS "${CMAKE_SOURCE_DIR}/cegui/include/CEGUI/Window.h")
 
    set(ALL_EVENTS_CODE "std::set<String> allEvents;")
 
    foreach (WIDGET_HEADER ${WIDGET_HEADERS})
        file(READ "${WIDGET_HEADER}" HEADER_SOURCE)
        string(REGEX MATCHALL "static const String Event[^;]+" MATCHED_LINES "${HEADER_SOURCE}")
        foreach (MATCHED_LINE ${MATCHED_LINES})
            string(REGEX REPLACE "static const String Event([^;]+)" "\\1" CAPTURE_GROUP "${MATCHED_LINE}")
            if (NOT CAPTURE_GROUP STREQUAL "Namespace")
                set(ALL_EVENTS_CODE "${ALL_EVENTS_CODE}\nallEvents.insert(\"${CAPTURE_GROUP}\");")
            endif()                                                                                      
        endforeach()
    endforeach()
 
    file(WRITE ${CMAKE_BINARY_DIR}/samples/common/include/AllEvents.inc "${ALL_EVENTS_CODE}")

    include_directories(${CMAKE_BINARY_DIR}/samples/common/include)
	
    
    cegui_add_sample(CEGUIWidgetDemo)
endif()

=== cegui/src/CommonDialogs/CMakeLists.txt ===
set (CEGUI_TARGET_NAME ${CEGUI_COMMON_DIALOGS_LIBNAME})

file (GLOB MODULE_SOURCE_FILES RELATIVE "${CMAKE_CURRENT_SOURCE_DIR}" *.cpp)
file (GLOB COLOUR_PICKER_SOURCE_FILES RELATIVE "${CMAKE_CURRENT_SOURCE_DIR}" ColourPicker/*.cpp)
set (CORE_SOURCE_FILES ${MODULE_SOURCE_FILES} ${COLOUR_PICKER_SOURCE_FILES})

file (GLOB MODULE_HEADER_FILES ../../include/CEGUI/CommonDialogs/*.h)
file (GLOB COLOUR_PICKER_HEADER_FILES ../../include/CEGUI/CommonDialogs/ColourPicker/*.h)
set (CORE_HEADER_FILES ${MODULE_HEADER_FILES} ${COLOUR_PICKER_HEADER_FILES})

# we do not use the common header install function since we need to install to
# multiple sub-dirs.
cegui_add_library_impl(${CEGUI_TARGET_NAME} FALSE CORE_SOURCE_FILES CORE_HEADER_FILES TRUE FALSE)
cegui_target_link_libraries(${CEGUI_TARGET_NAME} ${CEGUI_BASE_LIBNAME})

install(FILES ${MODULE_HEADER_FILES} DESTINATION ${CEGUI_INCLUDE_INSTALL_DIR}/CEGUI/CommonDialogs)
install(FILES ${COLOUR_PICKER_HEADER_FILES} DESTINATION ${CEGUI_INCLUDE_INSTALL_DIR}/CEGUI/CommonDialogs/ColourPicker)

=== cegui/src/WindowRendererSets/CMakeLists.txt ===
add_subdirectory(Core)

=== cegui/src/ImageCodecModules/Corona/CMakeLists.txt ===
set( CEGUI_TARGET_NAME ${CEGUI_CORONA_IMAGECODEC_LIBNAME} )

cegui_gather_files()
cegui_add_loadable_module(${CEGUI_TARGET_NAME} CORE_SOURCE_FILES CORE_HEADER_FILES)
cegui_add_dependency(${CEGUI_TARGET_NAME} CORONA)

cegui_target_link_libraries(${CEGUI_TARGET_NAME} ${CEGUI_BASE_LIBNAME})

=== cegui/src/ImageCodecModules/SDL2/CMakeLists.txt ===
set( CEGUI_TARGET_NAME ${CEGUI_SDL2_IMAGECODEC_LIBNAME} )

cegui_gather_files()
cegui_add_loadable_module(${CEGUI_TARGET_NAME} CORE_SOURCE_FILES CORE_HEADER_FILES)
cegui_add_dependency(${CEGUI_TARGET_NAME} SDL2)
cegui_add_dependency(${CEGUI_TARGET_NAME} SDL2IMAGE)

cegui_target_link_libraries(${CEGUI_TARGET_NAME} ${CEGUI_BASE_LIBNAME})

=== debian/changelog ===
cegui-mk2 (0.8.7-4) unstable; urgency=medium

  * Build extensions for only the default python version (Closes: #943611)
  * Remove python 2 package (Closes: #936279)
  * Update to compatibility level 12 and remove d/compat file
  * Update standards to 4.4.1 (no changes)
  * Specify Rules-Requires-Root: no
  * Fix python dependency scheme
  * Add d/symbols file

 -- Olek Wojnar <olekw.dev@gmail.com>  Sun, 08 Dec 2019 20:24:25 -0500

cegui-mk2 (0.8.7-3) unstable; urgency=medium

  * Update d/copyright:
    - Use secure URLs
    - Add myself to debian/*
    - Update debian/* copyright dates
    - Consolidate license information
    - Clarify an unnamed license as BSD-3-clause (char-for-char match)
  * Update d/control:
    - Move package maintenance under Debian Games Team
    - Add myself as secondary uploader
    - Update build-depend from pyside-tools to pyside2-tools (Closes: #910679)
    - Update VCS URLs
    - Update standards to 4.3.0 (no changes)
    - Add missing depends for -doc package (Closes: #924190)
    - Remove unnecessary build-depend on libdirectfb-dev (Closes: #855515)
    - Mark -doc package as Multi-Arch foreign, mark lib and -dev as MA same
  * Update d/rules:
    - Add fixfilepath to DEB_BUILD_MAINT_OPTIONS for build reproducibility
    - Use jdupes to replace duplicate documentation files with softlinks
  * Update d/debian/patches/xerces32_changes:
    - Add missing DEP 3 info
    - Add missing blank line at EOF
  * Update to compatibility level 11:
    - Update d/compat to 11
    - Update d/control build-deps: debhelper to >= 11 and remove dh-autoreconf
  * Add d/upstream/metadata: for DEP 12 compliance
  * Move from CDBS to debhelper:
    - Update d/control and d/rules
    - Remove unnecessary d/dirs files
    - Update d/install files
    - Update doxygenout patch
  * Enable support for both python2 and python3 (Closes: #739074):
    -- Update d/control, d/rules, and d/*libcegui-mk2-0.8.7.install
    -- Add d/patches/python3.patch
    -- Add python- and python3- .install files
  * Convert to automatic debug package: update d/control and d/rules
  * Remove obsolete patches
  * Create manpages and separate package for two bundled binaries
  * Move library data from -doc package to new -data and fonts- packages
  * Add lintian override for package-name-doesnt-match-sonames
  * Add d/patches/mizufalp.patch: Eliminate code references to removed font
  * Add d/patches/multi-arch.patch: Add support for Multi-Arch to CMake
  * Add d/relative_paths.patch: Remove absolute build path directory
  * Add d/jura_fonts.patch: Update references to changed Jura font
  * Add d/futhark_font.patch: Update code due to removal of space in filename

 -- Olek Wojnar <olekw.dev@gmail.com>  Tue, 02 Apr 2019 19:54:03 -0400

cegui-mk2 (0.8.7-2) unstable; urgency=medium

  * This upload fixes FTBFS caused by xerces-c3.2. Thanks to  William Blough
    for providing a patch (Closes: #881018).

 -- Muammar El Khatib <muammar@debian.org>  Thu, 16 Nov 2017 21:43:47 -0500

cegui-mk2 (0.8.7-1.3) unstable; urgency=medium

  * Non-maintainer upload.
  * Install required libs in main package, not in dev package (Closes: #833705)
  * Add patch to allow compiling on kFreeBSD

 -- Olek Wojnar <olek-dev@wojnar.org>  Sun, 21 Aug 2016 11:48:42 -0400

cegui-mk2 (0.8.7-1.2) unstable; urgency=medium

  * Non-maintainer upload.

  [ Frédéric Bonnard ]
  * Run autoreconf during the build.  Closes: #758528

  [ Mattia Rizzolo ]
  * Build depend on unversioned boost.  Closes: #833797

 -- Mattia Rizzolo <mattia@debian.org>  Wed, 10 Aug 2016 21:33:21 +0000

cegui-mk2 (0.8.7-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Switch to GLFW 3. (Closes: #826287)

 -- James Cowgill <jcowgill@debian.org>  Sat, 02 Jul 2016 22:22:02 +0200

cegui-mk2 (0.8.7-1) unstable; urgency=medium

  [ Muammar El Khatib ]
  * New upstream release.
  *  debian/control:
     + Build-depends on: libice-dev, libsm-dev, libirrlicht-dev.
     + libcegui-mk2-dev depends on libpng-dev instead of libpng16-dev
     | libpng-dev. Thanks to Gianfranco Costamagna for reporting this bug
     (Closes: #820307).

 -- Muammar El Khatib <muammar@debian.org>  Sat, 30 Apr 2016 17:18:49 +0200

cegui-mk2 (0.8.5-1) unstable; urgency=medium

  [ Muammar El Khatib ]
  * New upstream release.
  * debian/compat: bump to compat level 9.

 -- Muammar El Khatib <muammar@debian.org>  Tue, 29 Mar 2016 18:13:38 +0200

cegui-mk2 (0.8.4+dfsg-5) unstable; urgency=medium

  [ Muammar El Khatib ]
  * -DCEGUI_BUILD_RENDERER_OPENGL3=ON option is passed to build the package.
  * debian/control:
    + Build-depends on: mesa-utils-extra, libglapi-mesa, python-opengl,
    pyside-tools, libboost-python-dev.

 -- Muammar El Khatib <muammar@debian.org>  Mon, 28 Mar 2016 22:40:34 +0200

=== debian/control ===
Source: cegui-mk2
Section: libs
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders: Muammar El Khatib <muammar@debian.org>,
           Olek Wojnar <olekw.dev@gmail.com>
Build-Depends: cmake (>= 3.12.4),
               debhelper-compat (= 12),
               dh-python,
               doxygen,
               graphviz,
               jdupes,
               libboost-dev,
               libboost-python-dev,
               libboost-regex-dev,
               libboost-signals-dev,
               libdevil-dev,
               libexpat1-dev,
               libfreeimage-dev,
               libfreetype6-dev,
               libfribidi-dev,
               libgl1-mesa-dev,
               libglapi-mesa,
               libgles2-mesa-dev,
               libglew-dev,
               libglfw3-dev,
               libglm-dev,
               libglu1-mesa-dev,
               libgtk2.0-dev,
               libice-dev,
               libirrlicht-dev,
               libjs-jquery,
               libminizip-dev,
               libogre-1.9-dev,
               libois-dev [linux-any],
               libpcre3-dev,
               libpng-dev,
               librapidxml-dev,
               libsilly-dev,
               libsm-dev,
               libtiff-dev,
               libtinyxml-dev,
               libtolua++5.1-dev (>= 1.0.93),
               libxcursor-dev,
               libxerces-c-dev,
               libxml2-dev,
               libxpm-dev,
               libxxf86vm-dev,
               lua-expat-dev,
               lua5.1,
               mesa-utils-extra,
               pkg-config,
               pyside2-tools,
               python3-dev,
               python3-opengl,
               python3-setuptools,
Standards-Version: 4.4.1
Rules-Requires-Root: no
Homepage: https://www.cegui.org.uk/
VCS-Browser: https://salsa.debian.org/games-team/cegui-mk2
VCS-Git: https://salsa.debian.org/games-team/cegui-mk2.git

Package: libcegui-mk2-0.8.7
Architecture: any
Multi-Arch: same
Depends: libcegui-mk2-data (= ${source:Version}),
         ${shlibs:Depends},
         ${misc:Depends},
Recommends: python3-libcegui-mk2-0.8.7 (= ${binary:Version}),
Breaks: libsilly (<< 0.1.0-6.1)
Conflicts: libcegui-mk2-0c2a, libcegui-mk2-0.8.4
Replaces: libcegui-mk2-0c2a, libcegui-mk2-0.8.4
Description: Crazy Eddie's GUI (libraries)
 CEGUI is a free library providing windowing and widgets for graphics
 APIs and engines where such functionality is not natively available
 or is severely lacking. The library is written in C++, is object
 oriented, and is primarily targeted at games developers who should be
 spending their time creating great games, not building GUI sub-systems
 .
 This version of CEGUI natively supports the OpenGL rendering target.

Package: python3-libcegui-mk2-0.8.7
Section: python
Architecture: any
Multi-Arch: same
Depends: libcegui-mk2-0.8.7 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}, ${python3:Depends}
Breaks: libcegui-mk2-0.8.7 (<<0.8.7-3)
Replaces: libcegui-mk2-0.8.7 (<<0.8.7-3)
Description: Crazy Eddie's GUI (Python 3 Bindings)
 CEGUI is a free library providing windowing and widgets for graphics
 APIs and engines where such functionality is not natively available
 or is severely lacking. The library is written in C++, is object
 oriented, and is primarily targeted at games developers who should be
 spending their time creating great games, not building GUI sub-systems
 .
 This package contains the Python 3 bindings for the CEGUI library.

Package: libcegui-mk2-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libcegui-mk2-0.8.7 (= ${binary:Version}),
         libdevil-dev,
         libfreeimage-dev,
         libfreetype6-dev,
         libjpeg-dev,
         liblcms2-dev,
         libmng-dev,
         libpcre3-dev,
         libpng-dev,
         libtiff5-dev | libtiff-dev,
         libxerces-c3.2,
         lua-expat-dev,
         zlib1g-dev | libz-dev,
         ${shlibs:Depends},
         ${misc:Depends},
Suggests: libcegui-mk2-doc (= ${source:Version})
Description: Crazy Eddie's GUI (development files)
 CEGUI is a free library providing windowing and widgets for graphics
 APIs and engines where such functionality is not natively available
 or is severely lacking. The library is written in C++, is object
 oriented, and is primarily targeted at games developers who should be
 spending their time creating great games, not building GUI sub-systems
 .
 This package contains the development files for the CEGUI library.

Package: libcegui-mk2-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: libjs-jquery,
         ${misc:Depends},
Description: Crazy Eddie's GUI (documentation)
 CEGUI is a free library providing windowing and widgets for graphics
 APIs and engines where such functionality is not natively available
 or is severely lacking. The library is written in C++, is object
 oriented, and is primarily targeted at games developers who should be
 spending their time creating great games, not building GUI sub-systems
 .
 This package contains the documentation for the CEGUI library.

Package: libcegui-mk2-data
Section: graphics
Architecture: all
Multi-Arch: foreign
Depends: fonts-cegui (= ${source:Version}),
         fonts-baekmuk,
         fonts-dejavu-core,
         fonts-junicode,
         fonts-jura,
         ${misc:Depends},
Breaks: libcegui-mk2-0.8.7 (<<0.8.7-3)
Replaces: libcegui-mk2-0.8.7 (<<0.8.7-3)
Description: Crazy Eddie's GUI (data)
 CEGUI is a free library providing windowing and widgets for graphics
 APIs and engines where such functionality is not natively available
 or is severely lacking. The library is written in C++, is object
 oriented, and is primarily targeted at games developers who should be
 spending their time creating great games, not building GUI sub-systems
 .
 This package contains data files for the CEGUI library.

Package: fonts-cegui
Section: fonts
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends}
Breaks: libcegui-mk2-0.8.7 (<<0.8.7-3)
Replaces: libcegui-mk2-0.8.7 (<<0.8.7-3)
Description: Crazy Eddie's GUI (fonts)
 CEGUI is a free library providing windowing and widgets for graphics
 APIs and engines where such functionality is not natively available
 or is severely lacking. The library is written in C++, is object
 oriented, and is primarily targeted at games developers who should be
 spending their time creating great games, not building GUI sub-systems
 .
 This package contains font files for the CEGUI library that are not
 packaged separately.

Package: cegui-mk2-0.8.7
Section: graphics
Architecture: any
Enhances: libcegui-mk2-0.8.7 (= ${binary:Version})
Depends: ${shlibs:Depends}, ${misc:Depends}
Breaks: libcegui-mk2-0.8.7 (<<0.8.7-3)
Replaces: libcegui-mk2-0.8.7 (<<0.8.7-3)
Description: Crazy Eddie's GUI (executables)
 CEGUI is a free library providing windowing and widgets for graphics
 APIs and engines where such functionality is not natively available
 or is severely lacking. The library is written in C++, is object
 oriented, and is primarily targeted at games developers who should be
 spending their time creating great games, not building GUI sub-systems
 .
 This package contains the executables that support using the CEGUI library.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE = 1
export DEB_LDFLAGS_MAINT_APPEND = -llua5.1 -ldl
export DEB_BUILD_MAINT_OPTIONS = hardening=+all, reproducible=+fixfilepath

export AUTOMAKE = automake --foreign

%:
	dh $@ --with python3

override_dh_auto_configure:
		dh_auto_configure -- -DCEGUI_BUILD_RENDERER_DIRECTFB=OFF \
			-DCEGUI_SAMPLES_USE_DIRECTFB=OFF -DCEGUI_BUILD_RENDERER_OPENGL=ON \
			-DCEGUI_SAMPLES_USE_OGRE=ON -DCEGUI_BUILD_XMLPARSER_EXPAT=ON \
			-DCEGUI_BUILD_IMAGECODEC_SILLY=ON -DCEGUI_BUILD_IMAGECODEC_DEVIL=ON \
			-DCEGUI_BUILD_IMAGECODEC_FREEIMAGE=ON -DCEGUI_BUILD_RENDERER_NULL=ON \
			-DCEGUI_BUILD_PYTHON_MODULES=ON -DCEGUI_BUILD_XMLPARSER_TINYXML=ON \
			-DCEGUI_BUILD_XMLPARSER_XERCES=ON -DCEGUI_BUILD_RENDERER_OPENGL3=ON
		mv "datafiles/fonts/Futhark Adapted.ttf" datafiles/fonts/FutharkAdapted.ttf
		rm datafiles/fonts/Jura-*.ttf

override_dh_python3:
		dh_python3 --shebang=/usr/bin/python3

override_dh_strip:
		dh_strip --dbgsym-migration='libcegui-mk2-0.8.7-dbg (<< 0.8.7-3~)'

override_dh_auto_install:
		dh_auto_install
		jdupes -rl debian/tmp/usr/share/doc/libcegui-mk2-0.8.7/html
